// CheckStyle: stop header check
// GENERATED CONTENT - DO NOT EDIT
// Source: AMD64NodeLIRBuilder.java
package com.oracle.graal.compiler.amd64;

import java.util.*;
import java.lang.reflect.*;
import com.oracle.graal.compiler.match.*;
import com.oracle.graal.compiler.common.GraalInternalError;
import com.oracle.graal.compiler.gen.NodeLIRBuilder;
import com.oracle.graal.graph.NodeClass;
import com.oracle.graal.nodes.*;
import com.oracle.graal.nodes.calc.*;
import com.oracle.graal.nodes.extended.*;

public class AMD64NodeLIRBuilder_MatchStatementSet implements MatchStatementSet {

    private static Method lookupMethod(Class<?> theClass, String name, Class<?>... args) {
        try {
            return theClass.getDeclaredMethod(name, args);
        } catch (Exception e) {
            throw new GraalInternalError(e);
        }
    }

    private static final String[] rotateLeftConstant_arguments = new String[] {"lshift", "rshift"};
    private static final Method rotateLeftConstant_invoke = lookupMethod(AMD64NodeLIRBuilder.class, "rotateLeftConstant", LeftShiftNode.class, UnsignedRightShiftNode.class);

    private static final String[] rotateRightVariable_arguments = new String[] {"value", "delta", "shiftAmount"};
    private static final Method rotateRightVariable_invoke = lookupMethod(AMD64NodeLIRBuilder.class, "rotateRightVariable", ValueNode.class, ConstantNode.class, ValueNode.class);

    private static final String[] rotateLeftVariable_arguments = new String[] {"value", "shiftAmount", "delta"};
    private static final Method rotateLeftVariable_invoke = lookupMethod(AMD64NodeLIRBuilder.class, "rotateLeftVariable", ValueNode.class, ValueNode.class, ConstantNode.class);

    private static final String[] writeNarrow_arguments = new String[] {"root", "narrow"};
    private static final Method writeNarrow_invoke = lookupMethod(AMD64NodeLIRBuilder.class, "writeNarrow", WriteNode.class, NarrowNode.class);

    private static final String[] integerTestBranchMemory_arguments = new String[] {"root", "access", "value"};
    private static final Method integerTestBranchMemory_invoke = lookupMethod(AMD64NodeLIRBuilder.class, "integerTestBranchMemory", IfNode.class, Access.class, ValueNode.class);

    private static final String[] ifCompareMemory_arguments = new String[] {"root", "compare", "value", "access"};
    private static final Method ifCompareMemory_invoke = lookupMethod(AMD64NodeLIRBuilder.class, "ifCompareMemory", IfNode.class, CompareNode.class, ValueNode.class, Access.class);

    private static final String[] binaryRead_arguments = new String[] {"root", "value", "access"};
    private static final Method binaryRead_invoke = lookupMethod(AMD64NodeLIRBuilder.class, "binaryRead", BinaryNode.class, ValueNode.class, Access.class);

    private static final String[] signExtend_arguments = new String[] {"root", "access"};
    private static final Method signExtend_invoke = lookupMethod(AMD64NodeLIRBuilder.class, "signExtend", SignExtendNode.class, Access.class);

    private static final String[] zeroExtend_arguments = new String[] {"root", "access"};
    private static final Method zeroExtend_invoke = lookupMethod(AMD64NodeLIRBuilder.class, "zeroExtend", ZeroExtendNode.class, Access.class);

    private static final String[] floatConvert_arguments = new String[] {"root", "access"};
    private static final Method floatConvert_invoke = lookupMethod(AMD64NodeLIRBuilder.class, "floatConvert", FloatConvertNode.class, Access.class);

    private static final String[] reinterpret_arguments = new String[] {"root", "access"};
    private static final Method reinterpret_invoke = lookupMethod(AMD64NodeLIRBuilder.class, "reinterpret", ReinterpretNode.class, Access.class);

    private static final NodeClass.Position[] OrNode_positions = MatchPattern.findPositions(OrNode.class, new String[]{"x", "y"});
    private static final NodeClass.Position[] LeftShiftNode_positions = MatchPattern.findPositions(LeftShiftNode.class, new String[]{"x", "y"});
    private static final NodeClass.Position[] UnsignedRightShiftNode_positions = MatchPattern.findPositions(UnsignedRightShiftNode.class, new String[]{"x", "y"});
    private static final NodeClass.Position[] IntegerSubNode_positions = MatchPattern.findPositions(IntegerSubNode.class, new String[]{"x", "y"});
    private static final NodeClass.Position[] WriteNode_positions = MatchPattern.findPositions(WriteNode.class, new String[]{"object", "location", "value"});
    private static final NodeClass.Position[] IfNode_positions = MatchPattern.findPositions(IfNode.class, new String[]{"condition"});
    private static final NodeClass.Position[] IntegerTestNode_positions = MatchPattern.findPositions(IntegerTestNode.class, new String[]{"x", "y"});
    private static final NodeClass.Position[] IntegerEqualsNode_positions = MatchPattern.findPositions(IntegerEqualsNode.class, new String[]{"x", "y"});
    private static final NodeClass.Position[] IntegerLessThanNode_positions = MatchPattern.findPositions(IntegerLessThanNode.class, new String[]{"x", "y"});
    private static final NodeClass.Position[] IntegerBelowThanNode_positions = MatchPattern.findPositions(IntegerBelowThanNode.class, new String[]{"x", "y"});
    private static final NodeClass.Position[] FloatEqualsNode_positions = MatchPattern.findPositions(FloatEqualsNode.class, new String[]{"x", "y"});
    private static final NodeClass.Position[] FloatLessThanNode_positions = MatchPattern.findPositions(FloatLessThanNode.class, new String[]{"x", "y"});
    private static final NodeClass.Position[] IntegerAddNode_positions = MatchPattern.findPositions(IntegerAddNode.class, new String[]{"x", "y"});
    private static final NodeClass.Position[] IntegerMulNode_positions = MatchPattern.findPositions(IntegerMulNode.class, new String[]{"x", "y"});
    private static final NodeClass.Position[] FloatAddNode_positions = MatchPattern.findPositions(FloatAddNode.class, new String[]{"x", "y"});
    private static final NodeClass.Position[] FloatSubNode_positions = MatchPattern.findPositions(FloatSubNode.class, new String[]{"x", "y"});
    private static final NodeClass.Position[] FloatMulNode_positions = MatchPattern.findPositions(FloatMulNode.class, new String[]{"x", "y"});
    private static final NodeClass.Position[] XorNode_positions = MatchPattern.findPositions(XorNode.class, new String[]{"x", "y"});
    private static final NodeClass.Position[] AndNode_positions = MatchPattern.findPositions(AndNode.class, new String[]{"x", "y"});
    private static final NodeClass.Position[] SignExtendNode_positions = MatchPattern.findPositions(SignExtendNode.class, new String[]{"input"});
    private static final NodeClass.Position[] ZeroExtendNode_positions = MatchPattern.findPositions(ZeroExtendNode.class, new String[]{"input"});
    private static final NodeClass.Position[] FloatConvertNode_positions = MatchPattern.findPositions(FloatConvertNode.class, new String[]{"input"});
    private static final NodeClass.Position[] ReinterpretNode_positions = MatchPattern.findPositions(ReinterpretNode.class, new String[]{"value"});

    // CheckStyle: stop line length check
    private static final List<MatchStatement> statements = Collections.unmodifiableList(Arrays.asList(
        new MatchStatement("rotateLeftConstant", new MatchPattern(OrNode.class, null, new MatchPattern(LeftShiftNode.class, "lshift", new MatchPattern("value", false), new MatchPattern(ConstantNode.class, null, false), LeftShiftNode_positions, true), new MatchPattern(UnsignedRightShiftNode.class, "rshift", new MatchPattern("value", false), new MatchPattern(ConstantNode.class, null, false), UnsignedRightShiftNode_positions, true), OrNode_positions, true), rotateLeftConstant_invoke, rotateLeftConstant_arguments),
        new MatchStatement("rotateLeftConstant", new MatchPattern(OrNode.class, null, new MatchPattern(UnsignedRightShiftNode.class, "rshift", new MatchPattern("value", false), new MatchPattern(ConstantNode.class, null, false), UnsignedRightShiftNode_positions, true), new MatchPattern(LeftShiftNode.class, "lshift", new MatchPattern("value", false), new MatchPattern(ConstantNode.class, null, false), LeftShiftNode_positions, true), OrNode_positions, true), rotateLeftConstant_invoke, rotateLeftConstant_arguments),
        new MatchStatement("rotateRightVariable", new MatchPattern(OrNode.class, null, new MatchPattern(LeftShiftNode.class, null, new MatchPattern("value", false), new MatchPattern(IntegerSubNode.class, null, new MatchPattern(ConstantNode.class, "delta", false), new MatchPattern("shiftAmount", false), IntegerSubNode_positions, true), LeftShiftNode_positions, true), new MatchPattern(UnsignedRightShiftNode.class, null, new MatchPattern("value", false), new MatchPattern("shiftAmount", false), UnsignedRightShiftNode_positions, true), OrNode_positions, true), rotateRightVariable_invoke, rotateRightVariable_arguments),
        new MatchStatement("rotateRightVariable", new MatchPattern(OrNode.class, null, new MatchPattern(UnsignedRightShiftNode.class, null, new MatchPattern("value", false), new MatchPattern("shiftAmount", false), UnsignedRightShiftNode_positions, true), new MatchPattern(LeftShiftNode.class, null, new MatchPattern("value", false), new MatchPattern(IntegerSubNode.class, null, new MatchPattern(ConstantNode.class, "delta", false), new MatchPattern("shiftAmount", false), IntegerSubNode_positions, true), LeftShiftNode_positions, true), OrNode_positions, true), rotateRightVariable_invoke, rotateRightVariable_arguments),
        new MatchStatement("rotateLeftVariable", new MatchPattern(OrNode.class, null, new MatchPattern(LeftShiftNode.class, null, new MatchPattern("value", false), new MatchPattern("shiftAmount", false), LeftShiftNode_positions, true), new MatchPattern(UnsignedRightShiftNode.class, null, new MatchPattern("value", false), new MatchPattern(IntegerSubNode.class, null, new MatchPattern(ConstantNode.class, "delta", false), new MatchPattern("shiftAmount", false), IntegerSubNode_positions, true), UnsignedRightShiftNode_positions, true), OrNode_positions, true), rotateLeftVariable_invoke, rotateLeftVariable_arguments),
        new MatchStatement("rotateLeftVariable", new MatchPattern(OrNode.class, null, new MatchPattern(UnsignedRightShiftNode.class, null, new MatchPattern("value", false), new MatchPattern(IntegerSubNode.class, null, new MatchPattern(ConstantNode.class, "delta", false), new MatchPattern("shiftAmount", false), IntegerSubNode_positions, true), UnsignedRightShiftNode_positions, true), new MatchPattern(LeftShiftNode.class, null, new MatchPattern("value", false), new MatchPattern("shiftAmount", false), LeftShiftNode_positions, true), OrNode_positions, true), rotateLeftVariable_invoke, rotateLeftVariable_arguments),
        new MatchStatement("writeNarrow", new MatchPattern(WriteNode.class, null, new MatchPattern(NarrowNode.class, "narrow", true), new MatchPattern("location", false), new MatchPattern("value", false), WriteNode_positions, true), writeNarrow_invoke, writeNarrow_arguments),
        new MatchStatement("integerTestBranchMemory", new MatchPattern(IfNode.class, null, new MatchPattern(IntegerTestNode.class, null, new MatchPattern(ReadNode.class, "access", true), new MatchPattern("value", false), IntegerTestNode_positions, true), IfNode_positions, true), integerTestBranchMemory_invoke, integerTestBranchMemory_arguments),
        new MatchStatement("integerTestBranchMemory", new MatchPattern(IfNode.class, null, new MatchPattern(IntegerTestNode.class, null, new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", true), IntegerTestNode_positions, true), IfNode_positions, true), integerTestBranchMemory_invoke, integerTestBranchMemory_arguments),
        new MatchStatement("integerTestBranchMemory", new MatchPattern(IfNode.class, null, new MatchPattern(IntegerTestNode.class, null, new MatchPattern(FloatingReadNode.class, "access", true), new MatchPattern("value", false), IntegerTestNode_positions, true), IfNode_positions, true), integerTestBranchMemory_invoke, integerTestBranchMemory_arguments),
        new MatchStatement("integerTestBranchMemory", new MatchPattern(IfNode.class, null, new MatchPattern(IntegerTestNode.class, null, new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", true), IntegerTestNode_positions, true), IfNode_positions, true), integerTestBranchMemory_invoke, integerTestBranchMemory_arguments),
        new MatchStatement("ifCompareMemory", new MatchPattern(IfNode.class, null, new MatchPattern(IntegerEqualsNode.class, "compare", new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", true), IntegerEqualsNode_positions, true), IfNode_positions, true), ifCompareMemory_invoke, ifCompareMemory_arguments),
        new MatchStatement("ifCompareMemory", new MatchPattern(IfNode.class, null, new MatchPattern(IntegerEqualsNode.class, "compare", new MatchPattern(ReadNode.class, "access", true), new MatchPattern("value", false), IntegerEqualsNode_positions, true), IfNode_positions, true), ifCompareMemory_invoke, ifCompareMemory_arguments),
        new MatchStatement("ifCompareMemory", new MatchPattern(IfNode.class, null, new MatchPattern(IntegerLessThanNode.class, "compare", new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", true), IntegerLessThanNode_positions, true), IfNode_positions, true), ifCompareMemory_invoke, ifCompareMemory_arguments),
        new MatchStatement("ifCompareMemory", new MatchPattern(IfNode.class, null, new MatchPattern(IntegerLessThanNode.class, "compare", new MatchPattern(ReadNode.class, "access", true), new MatchPattern("value", false), IntegerLessThanNode_positions, true), IfNode_positions, true), ifCompareMemory_invoke, ifCompareMemory_arguments),
        new MatchStatement("ifCompareMemory", new MatchPattern(IfNode.class, null, new MatchPattern(IntegerBelowThanNode.class, "compare", new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", true), IntegerBelowThanNode_positions, true), IfNode_positions, true), ifCompareMemory_invoke, ifCompareMemory_arguments),
        new MatchStatement("ifCompareMemory", new MatchPattern(IfNode.class, null, new MatchPattern(IntegerBelowThanNode.class, "compare", new MatchPattern(ReadNode.class, "access", true), new MatchPattern("value", false), IntegerBelowThanNode_positions, true), IfNode_positions, true), ifCompareMemory_invoke, ifCompareMemory_arguments),
        new MatchStatement("ifCompareMemory", new MatchPattern(IfNode.class, null, new MatchPattern(IntegerEqualsNode.class, "compare", new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", true), IntegerEqualsNode_positions, true), IfNode_positions, true), ifCompareMemory_invoke, ifCompareMemory_arguments),
        new MatchStatement("ifCompareMemory", new MatchPattern(IfNode.class, null, new MatchPattern(IntegerEqualsNode.class, "compare", new MatchPattern(FloatingReadNode.class, "access", true), new MatchPattern("value", false), IntegerEqualsNode_positions, true), IfNode_positions, true), ifCompareMemory_invoke, ifCompareMemory_arguments),
        new MatchStatement("ifCompareMemory", new MatchPattern(IfNode.class, null, new MatchPattern(IntegerLessThanNode.class, "compare", new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", true), IntegerLessThanNode_positions, true), IfNode_positions, true), ifCompareMemory_invoke, ifCompareMemory_arguments),
        new MatchStatement("ifCompareMemory", new MatchPattern(IfNode.class, null, new MatchPattern(IntegerLessThanNode.class, "compare", new MatchPattern(FloatingReadNode.class, "access", true), new MatchPattern("value", false), IntegerLessThanNode_positions, true), IfNode_positions, true), ifCompareMemory_invoke, ifCompareMemory_arguments),
        new MatchStatement("ifCompareMemory", new MatchPattern(IfNode.class, null, new MatchPattern(IntegerBelowThanNode.class, "compare", new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", true), IntegerBelowThanNode_positions, true), IfNode_positions, true), ifCompareMemory_invoke, ifCompareMemory_arguments),
        new MatchStatement("ifCompareMemory", new MatchPattern(IfNode.class, null, new MatchPattern(IntegerBelowThanNode.class, "compare", new MatchPattern(FloatingReadNode.class, "access", true), new MatchPattern("value", false), IntegerBelowThanNode_positions, true), IfNode_positions, true), ifCompareMemory_invoke, ifCompareMemory_arguments),
        new MatchStatement("ifCompareMemory", new MatchPattern(IfNode.class, null, new MatchPattern(FloatEqualsNode.class, "compare", new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", true), FloatEqualsNode_positions, true), IfNode_positions, true), ifCompareMemory_invoke, ifCompareMemory_arguments),
        new MatchStatement("ifCompareMemory", new MatchPattern(IfNode.class, null, new MatchPattern(FloatEqualsNode.class, "compare", new MatchPattern(ReadNode.class, "access", true), new MatchPattern("value", false), FloatEqualsNode_positions, true), IfNode_positions, true), ifCompareMemory_invoke, ifCompareMemory_arguments),
        new MatchStatement("ifCompareMemory", new MatchPattern(IfNode.class, null, new MatchPattern(FloatEqualsNode.class, "compare", new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", true), FloatEqualsNode_positions, true), IfNode_positions, true), ifCompareMemory_invoke, ifCompareMemory_arguments),
        new MatchStatement("ifCompareMemory", new MatchPattern(IfNode.class, null, new MatchPattern(FloatEqualsNode.class, "compare", new MatchPattern(FloatingReadNode.class, "access", true), new MatchPattern("value", false), FloatEqualsNode_positions, true), IfNode_positions, true), ifCompareMemory_invoke, ifCompareMemory_arguments),
        new MatchStatement("ifCompareMemory", new MatchPattern(IfNode.class, null, new MatchPattern(FloatLessThanNode.class, "compare", new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", true), FloatLessThanNode_positions, true), IfNode_positions, true), ifCompareMemory_invoke, ifCompareMemory_arguments),
        new MatchStatement("ifCompareMemory", new MatchPattern(IfNode.class, null, new MatchPattern(FloatLessThanNode.class, "compare", new MatchPattern(ReadNode.class, "access", true), new MatchPattern("value", false), FloatLessThanNode_positions, true), IfNode_positions, true), ifCompareMemory_invoke, ifCompareMemory_arguments),
        new MatchStatement("ifCompareMemory", new MatchPattern(IfNode.class, null, new MatchPattern(FloatLessThanNode.class, "compare", new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", true), FloatLessThanNode_positions, true), IfNode_positions, true), ifCompareMemory_invoke, ifCompareMemory_arguments),
        new MatchStatement("ifCompareMemory", new MatchPattern(IfNode.class, null, new MatchPattern(FloatLessThanNode.class, "compare", new MatchPattern(FloatingReadNode.class, "access", true), new MatchPattern("value", false), FloatLessThanNode_positions, true), IfNode_positions, true), ifCompareMemory_invoke, ifCompareMemory_arguments),
        new MatchStatement("binaryRead", new MatchPattern(IntegerAddNode.class, null, new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", true), IntegerAddNode_positions, true), binaryRead_invoke, binaryRead_arguments),
        new MatchStatement("binaryRead", new MatchPattern(IntegerAddNode.class, null, new MatchPattern(ReadNode.class, "access", true), new MatchPattern("value", false), IntegerAddNode_positions, true), binaryRead_invoke, binaryRead_arguments),
        new MatchStatement("binaryRead", new MatchPattern(IntegerSubNode.class, null, new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", true), IntegerSubNode_positions, true), binaryRead_invoke, binaryRead_arguments),
        new MatchStatement("binaryRead", new MatchPattern(IntegerMulNode.class, null, new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", true), IntegerMulNode_positions, true), binaryRead_invoke, binaryRead_arguments),
        new MatchStatement("binaryRead", new MatchPattern(IntegerMulNode.class, null, new MatchPattern(ReadNode.class, "access", true), new MatchPattern("value", false), IntegerMulNode_positions, true), binaryRead_invoke, binaryRead_arguments),
        new MatchStatement("binaryRead", new MatchPattern(FloatAddNode.class, null, new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", true), FloatAddNode_positions, true), binaryRead_invoke, binaryRead_arguments),
        new MatchStatement("binaryRead", new MatchPattern(FloatAddNode.class, null, new MatchPattern(ReadNode.class, "access", true), new MatchPattern("value", false), FloatAddNode_positions, true), binaryRead_invoke, binaryRead_arguments),
        new MatchStatement("binaryRead", new MatchPattern(FloatSubNode.class, null, new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", true), FloatSubNode_positions, true), binaryRead_invoke, binaryRead_arguments),
        new MatchStatement("binaryRead", new MatchPattern(FloatMulNode.class, null, new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", true), FloatMulNode_positions, true), binaryRead_invoke, binaryRead_arguments),
        new MatchStatement("binaryRead", new MatchPattern(FloatMulNode.class, null, new MatchPattern(ReadNode.class, "access", true), new MatchPattern("value", false), FloatMulNode_positions, true), binaryRead_invoke, binaryRead_arguments),
        new MatchStatement("binaryRead", new MatchPattern(OrNode.class, null, new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", true), OrNode_positions, true), binaryRead_invoke, binaryRead_arguments),
        new MatchStatement("binaryRead", new MatchPattern(OrNode.class, null, new MatchPattern(ReadNode.class, "access", true), new MatchPattern("value", false), OrNode_positions, true), binaryRead_invoke, binaryRead_arguments),
        new MatchStatement("binaryRead", new MatchPattern(XorNode.class, null, new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", true), XorNode_positions, true), binaryRead_invoke, binaryRead_arguments),
        new MatchStatement("binaryRead", new MatchPattern(XorNode.class, null, new MatchPattern(ReadNode.class, "access", true), new MatchPattern("value", false), XorNode_positions, true), binaryRead_invoke, binaryRead_arguments),
        new MatchStatement("binaryRead", new MatchPattern(AndNode.class, null, new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", true), AndNode_positions, true), binaryRead_invoke, binaryRead_arguments),
        new MatchStatement("binaryRead", new MatchPattern(AndNode.class, null, new MatchPattern(ReadNode.class, "access", true), new MatchPattern("value", false), AndNode_positions, true), binaryRead_invoke, binaryRead_arguments),
        new MatchStatement("binaryRead", new MatchPattern(IntegerAddNode.class, null, new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", true), IntegerAddNode_positions, true), binaryRead_invoke, binaryRead_arguments),
        new MatchStatement("binaryRead", new MatchPattern(IntegerAddNode.class, null, new MatchPattern(FloatingReadNode.class, "access", true), new MatchPattern("value", false), IntegerAddNode_positions, true), binaryRead_invoke, binaryRead_arguments),
        new MatchStatement("binaryRead", new MatchPattern(IntegerSubNode.class, null, new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", true), IntegerSubNode_positions, true), binaryRead_invoke, binaryRead_arguments),
        new MatchStatement("binaryRead", new MatchPattern(IntegerMulNode.class, null, new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", true), IntegerMulNode_positions, true), binaryRead_invoke, binaryRead_arguments),
        new MatchStatement("binaryRead", new MatchPattern(IntegerMulNode.class, null, new MatchPattern(FloatingReadNode.class, "access", true), new MatchPattern("value", false), IntegerMulNode_positions, true), binaryRead_invoke, binaryRead_arguments),
        new MatchStatement("binaryRead", new MatchPattern(FloatAddNode.class, null, new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", true), FloatAddNode_positions, true), binaryRead_invoke, binaryRead_arguments),
        new MatchStatement("binaryRead", new MatchPattern(FloatAddNode.class, null, new MatchPattern(FloatingReadNode.class, "access", true), new MatchPattern("value", false), FloatAddNode_positions, true), binaryRead_invoke, binaryRead_arguments),
        new MatchStatement("binaryRead", new MatchPattern(FloatSubNode.class, null, new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", true), FloatSubNode_positions, true), binaryRead_invoke, binaryRead_arguments),
        new MatchStatement("binaryRead", new MatchPattern(FloatMulNode.class, null, new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", true), FloatMulNode_positions, true), binaryRead_invoke, binaryRead_arguments),
        new MatchStatement("binaryRead", new MatchPattern(FloatMulNode.class, null, new MatchPattern(FloatingReadNode.class, "access", true), new MatchPattern("value", false), FloatMulNode_positions, true), binaryRead_invoke, binaryRead_arguments),
        new MatchStatement("binaryRead", new MatchPattern(OrNode.class, null, new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", true), OrNode_positions, true), binaryRead_invoke, binaryRead_arguments),
        new MatchStatement("binaryRead", new MatchPattern(OrNode.class, null, new MatchPattern(FloatingReadNode.class, "access", true), new MatchPattern("value", false), OrNode_positions, true), binaryRead_invoke, binaryRead_arguments),
        new MatchStatement("binaryRead", new MatchPattern(XorNode.class, null, new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", true), XorNode_positions, true), binaryRead_invoke, binaryRead_arguments),
        new MatchStatement("binaryRead", new MatchPattern(XorNode.class, null, new MatchPattern(FloatingReadNode.class, "access", true), new MatchPattern("value", false), XorNode_positions, true), binaryRead_invoke, binaryRead_arguments),
        new MatchStatement("binaryRead", new MatchPattern(AndNode.class, null, new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", true), AndNode_positions, true), binaryRead_invoke, binaryRead_arguments),
        new MatchStatement("binaryRead", new MatchPattern(AndNode.class, null, new MatchPattern(FloatingReadNode.class, "access", true), new MatchPattern("value", false), AndNode_positions, true), binaryRead_invoke, binaryRead_arguments),
        new MatchStatement("signExtend", new MatchPattern(SignExtendNode.class, null, new MatchPattern(ReadNode.class, "access", true), SignExtendNode_positions, true), signExtend_invoke, signExtend_arguments),
        new MatchStatement("signExtend", new MatchPattern(SignExtendNode.class, null, new MatchPattern(FloatingReadNode.class, "access", true), SignExtendNode_positions, true), signExtend_invoke, signExtend_arguments),
        new MatchStatement("zeroExtend", new MatchPattern(ZeroExtendNode.class, null, new MatchPattern(ReadNode.class, "access", true), ZeroExtendNode_positions, true), zeroExtend_invoke, zeroExtend_arguments),
        new MatchStatement("zeroExtend", new MatchPattern(ZeroExtendNode.class, null, new MatchPattern(FloatingReadNode.class, "access", true), ZeroExtendNode_positions, true), zeroExtend_invoke, zeroExtend_arguments),
        new MatchStatement("floatConvert", new MatchPattern(FloatConvertNode.class, null, new MatchPattern(ReadNode.class, "access", true), FloatConvertNode_positions, true), floatConvert_invoke, floatConvert_arguments),
        new MatchStatement("floatConvert", new MatchPattern(FloatConvertNode.class, null, new MatchPattern(FloatingReadNode.class, "access", true), FloatConvertNode_positions, true), floatConvert_invoke, floatConvert_arguments),
        new MatchStatement("reinterpret", new MatchPattern(ReinterpretNode.class, null, new MatchPattern(ReadNode.class, "access", true), ReinterpretNode_positions, true), reinterpret_invoke, reinterpret_arguments),
        new MatchStatement("reinterpret", new MatchPattern(ReinterpretNode.class, null, new MatchPattern(FloatingReadNode.class, "access", true), ReinterpretNode_positions, true), reinterpret_invoke, reinterpret_arguments)
    ));
    // CheckStyle: resume line length check

    public Class<? extends NodeLIRBuilder> forClass() {
        return AMD64NodeLIRBuilder.class;
    }

    @Override
    public List<MatchStatement> statements() {
        return statements;
    }
}
