// CheckStyle: stop header check
// GENERATED CONTENT - DO NOT EDIT
// Source: AMD64HotSpotNodeLIRBuilder.java
package com.oracle.graal.hotspot.amd64;

import java.util.*;
import java.lang.reflect.*;
import com.oracle.graal.compiler.match.*;
import com.oracle.graal.compiler.common.GraalInternalError;
import com.oracle.graal.compiler.gen.NodeLIRBuilder;
import com.oracle.graal.graph.NodeClass;
import com.oracle.graal.hotspot.nodes.*;
import com.oracle.graal.nodes.*;
import com.oracle.graal.nodes.calc.*;
import com.oracle.graal.nodes.extended.*;

public class AMD64HotSpotNodeLIRBuilder_MatchStatementSet implements MatchStatementSet {

    private static Method lookupMethod(Class<?> theClass, String name, Class<?>... args) {
        try {
            return theClass.getDeclaredMethod(name, args);
        } catch (Exception e) {
            throw new GraalInternalError(e);
        }
    }

    private static final String[] ifCompareMemoryObject_arguments = new String[] {"root", "compare", "value", "access"};
    private static final Method ifCompareMemoryObject_invoke = lookupMethod(AMD64HotSpotNodeLIRBuilder.class, "ifCompareMemoryObject", IfNode.class, CompareNode.class, ValueNode.class, Access.class);

    private static final String[] ifCompareCompressedMemory_arguments = new String[] {"root", "compare", "compress", "value", "location", "access"};
    private static final Method ifCompareCompressedMemory_invoke = lookupMethod(AMD64HotSpotNodeLIRBuilder.class, "ifCompareCompressedMemory", IfNode.class, CompareNode.class, CompressionNode.class, ValueNode.class, ConstantLocationNode.class, Access.class);

    private static final String[] binaryReadCompressed_arguments = new String[] {"root", "value", "access", "compress", "location"};
    private static final Method binaryReadCompressed_invoke = lookupMethod(AMD64HotSpotNodeLIRBuilder.class, "binaryReadCompressed", BinaryNode.class, ValueNode.class, Access.class, CompressionNode.class, ConstantLocationNode.class);

    private static final String[] readCompressed_arguments = new String[] {"root", "compress", "location"};
    private static final Method readCompressed_invoke = lookupMethod(AMD64HotSpotNodeLIRBuilder.class, "readCompressed", Access.class, CompressionNode.class, ConstantLocationNode.class);

    private static final String[] writeCompressed_arguments = new String[] {"root", "compress", "location", "value"};
    private static final Method writeCompressed_invoke = lookupMethod(AMD64HotSpotNodeLIRBuilder.class, "writeCompressed", Access.class, CompressionNode.class, ConstantLocationNode.class, ValueNode.class);

    private static final NodeClass.Position[] IfNode_positions = MatchPattern.findPositions(IfNode.class, new String[]{"condition"});
    private static final NodeClass.Position[] ObjectEqualsNode_positions = MatchPattern.findPositions(ObjectEqualsNode.class, new String[]{"x", "y"});
    private static final NodeClass.Position[] PiNode_positions = MatchPattern.findPositions(PiNode.class, new String[]{"object"});
    private static final NodeClass.Position[] CompressionNode_positions = MatchPattern.findPositions(CompressionNode.class, new String[]{"input"});
    private static final NodeClass.Position[] IntegerEqualsNode_positions = MatchPattern.findPositions(IntegerEqualsNode.class, new String[]{"x", "y"});
    private static final NodeClass.Position[] FloatingReadNode_positions = MatchPattern.findPositions(FloatingReadNode.class, new String[]{"object", "location"});
    private static final NodeClass.Position[] IntegerLessThanNode_positions = MatchPattern.findPositions(IntegerLessThanNode.class, new String[]{"x", "y"});
    private static final NodeClass.Position[] IntegerBelowThanNode_positions = MatchPattern.findPositions(IntegerBelowThanNode.class, new String[]{"x", "y"});
    private static final NodeClass.Position[] FloatEqualsNode_positions = MatchPattern.findPositions(FloatEqualsNode.class, new String[]{"x", "y"});
    private static final NodeClass.Position[] FloatLessThanNode_positions = MatchPattern.findPositions(FloatLessThanNode.class, new String[]{"x", "y"});
    private static final NodeClass.Position[] ReadNode_positions = MatchPattern.findPositions(ReadNode.class, new String[]{"object", "location"});
    private static final NodeClass.Position[] IntegerAddNode_positions = MatchPattern.findPositions(IntegerAddNode.class, new String[]{"x", "y"});
    private static final NodeClass.Position[] IntegerSubNode_positions = MatchPattern.findPositions(IntegerSubNode.class, new String[]{"x", "y"});
    private static final NodeClass.Position[] IntegerMulNode_positions = MatchPattern.findPositions(IntegerMulNode.class, new String[]{"x", "y"});
    private static final NodeClass.Position[] FloatAddNode_positions = MatchPattern.findPositions(FloatAddNode.class, new String[]{"x", "y"});
    private static final NodeClass.Position[] FloatSubNode_positions = MatchPattern.findPositions(FloatSubNode.class, new String[]{"x", "y"});
    private static final NodeClass.Position[] FloatMulNode_positions = MatchPattern.findPositions(FloatMulNode.class, new String[]{"x", "y"});
    private static final NodeClass.Position[] OrNode_positions = MatchPattern.findPositions(OrNode.class, new String[]{"x", "y"});
    private static final NodeClass.Position[] XorNode_positions = MatchPattern.findPositions(XorNode.class, new String[]{"x", "y"});
    private static final NodeClass.Position[] AndNode_positions = MatchPattern.findPositions(AndNode.class, new String[]{"x", "y"});
    private static final NodeClass.Position[] WriteNode_positions = MatchPattern.findPositions(WriteNode.class, new String[]{"object", "location", "value"});

    // CheckStyle: stop line length check
    private static final List<MatchStatement> statements = Collections.unmodifiableList(Arrays.asList(
        new MatchStatement("ifCompareMemoryObject", new MatchPattern(IfNode.class, null, new MatchPattern(ObjectEqualsNode.class, "compare", new MatchPattern(ConstantNode.class, "value", false), new MatchPattern(PiNode.class, null, new MatchPattern(CompressionNode.class, null, new MatchPattern(ReadNode.class, "access", true), CompressionNode_positions, true), PiNode_positions, true), ObjectEqualsNode_positions, true), IfNode_positions, true), ifCompareMemoryObject_invoke, ifCompareMemoryObject_arguments),
        new MatchStatement("ifCompareMemoryObject", new MatchPattern(IfNode.class, null, new MatchPattern(ObjectEqualsNode.class, "compare", new MatchPattern(PiNode.class, null, new MatchPattern(CompressionNode.class, null, new MatchPattern(ReadNode.class, "access", true), CompressionNode_positions, true), PiNode_positions, true), new MatchPattern(ConstantNode.class, "value", false), ObjectEqualsNode_positions, true), IfNode_positions, true), ifCompareMemoryObject_invoke, ifCompareMemoryObject_arguments),
        new MatchStatement("ifCompareMemoryObject", new MatchPattern(IfNode.class, null, new MatchPattern(ObjectEqualsNode.class, "compare", new MatchPattern(ConstantNode.class, "value", false), new MatchPattern(PiNode.class, null, new MatchPattern(CompressionNode.class, null, new MatchPattern(FloatingReadNode.class, "access", true), CompressionNode_positions, true), PiNode_positions, true), ObjectEqualsNode_positions, true), IfNode_positions, true), ifCompareMemoryObject_invoke, ifCompareMemoryObject_arguments),
        new MatchStatement("ifCompareMemoryObject", new MatchPattern(IfNode.class, null, new MatchPattern(ObjectEqualsNode.class, "compare", new MatchPattern(PiNode.class, null, new MatchPattern(CompressionNode.class, null, new MatchPattern(FloatingReadNode.class, "access", true), CompressionNode_positions, true), PiNode_positions, true), new MatchPattern(ConstantNode.class, "value", false), ObjectEqualsNode_positions, true), IfNode_positions, true), ifCompareMemoryObject_invoke, ifCompareMemoryObject_arguments),
        new MatchStatement("ifCompareMemoryObject", new MatchPattern(IfNode.class, null, new MatchPattern(ObjectEqualsNode.class, "compare", new MatchPattern(CompressionNode.class, null, new MatchPattern("value", false), CompressionNode_positions, true), new MatchPattern(PiNode.class, null, new MatchPattern(CompressionNode.class, null, new MatchPattern(ReadNode.class, "access", true), CompressionNode_positions, true), PiNode_positions, true), ObjectEqualsNode_positions, true), IfNode_positions, true), ifCompareMemoryObject_invoke, ifCompareMemoryObject_arguments),
        new MatchStatement("ifCompareMemoryObject", new MatchPattern(IfNode.class, null, new MatchPattern(ObjectEqualsNode.class, "compare", new MatchPattern(PiNode.class, null, new MatchPattern(CompressionNode.class, null, new MatchPattern(ReadNode.class, "access", true), CompressionNode_positions, true), PiNode_positions, true), new MatchPattern(CompressionNode.class, null, new MatchPattern("value", false), CompressionNode_positions, true), ObjectEqualsNode_positions, true), IfNode_positions, true), ifCompareMemoryObject_invoke, ifCompareMemoryObject_arguments),
        new MatchStatement("ifCompareMemoryObject", new MatchPattern(IfNode.class, null, new MatchPattern(ObjectEqualsNode.class, "compare", new MatchPattern(CompressionNode.class, null, new MatchPattern("value", false), CompressionNode_positions, true), new MatchPattern(PiNode.class, null, new MatchPattern(CompressionNode.class, null, new MatchPattern(FloatingReadNode.class, "access", true), CompressionNode_positions, true), PiNode_positions, true), ObjectEqualsNode_positions, true), IfNode_positions, true), ifCompareMemoryObject_invoke, ifCompareMemoryObject_arguments),
        new MatchStatement("ifCompareMemoryObject", new MatchPattern(IfNode.class, null, new MatchPattern(ObjectEqualsNode.class, "compare", new MatchPattern(PiNode.class, null, new MatchPattern(CompressionNode.class, null, new MatchPattern(FloatingReadNode.class, "access", true), CompressionNode_positions, true), PiNode_positions, true), new MatchPattern(CompressionNode.class, null, new MatchPattern("value", false), CompressionNode_positions, true), ObjectEqualsNode_positions, true), IfNode_positions, true), ifCompareMemoryObject_invoke, ifCompareMemoryObject_arguments),
        new MatchStatement("ifCompareMemoryObject", new MatchPattern(IfNode.class, null, new MatchPattern(ObjectEqualsNode.class, "compare", new MatchPattern(ConstantNode.class, "value", false), new MatchPattern(CompressionNode.class, null, new MatchPattern(ReadNode.class, "access", true), CompressionNode_positions, true), ObjectEqualsNode_positions, true), IfNode_positions, true), ifCompareMemoryObject_invoke, ifCompareMemoryObject_arguments),
        new MatchStatement("ifCompareMemoryObject", new MatchPattern(IfNode.class, null, new MatchPattern(ObjectEqualsNode.class, "compare", new MatchPattern(CompressionNode.class, null, new MatchPattern(ReadNode.class, "access", true), CompressionNode_positions, true), new MatchPattern(ConstantNode.class, "value", false), ObjectEqualsNode_positions, true), IfNode_positions, true), ifCompareMemoryObject_invoke, ifCompareMemoryObject_arguments),
        new MatchStatement("ifCompareMemoryObject", new MatchPattern(IfNode.class, null, new MatchPattern(ObjectEqualsNode.class, "compare", new MatchPattern(ConstantNode.class, "value", false), new MatchPattern(CompressionNode.class, null, new MatchPattern(FloatingReadNode.class, "access", true), CompressionNode_positions, true), ObjectEqualsNode_positions, true), IfNode_positions, true), ifCompareMemoryObject_invoke, ifCompareMemoryObject_arguments),
        new MatchStatement("ifCompareMemoryObject", new MatchPattern(IfNode.class, null, new MatchPattern(ObjectEqualsNode.class, "compare", new MatchPattern(CompressionNode.class, null, new MatchPattern(FloatingReadNode.class, "access", true), CompressionNode_positions, true), new MatchPattern(ConstantNode.class, "value", false), ObjectEqualsNode_positions, true), IfNode_positions, true), ifCompareMemoryObject_invoke, ifCompareMemoryObject_arguments),
        new MatchStatement("ifCompareMemoryObject", new MatchPattern(IfNode.class, null, new MatchPattern(ObjectEqualsNode.class, "compare", new MatchPattern(CompressionNode.class, null, new MatchPattern("value", false), CompressionNode_positions, true), new MatchPattern(CompressionNode.class, null, new MatchPattern(ReadNode.class, "access", true), CompressionNode_positions, true), ObjectEqualsNode_positions, true), IfNode_positions, true), ifCompareMemoryObject_invoke, ifCompareMemoryObject_arguments),
        new MatchStatement("ifCompareMemoryObject", new MatchPattern(IfNode.class, null, new MatchPattern(ObjectEqualsNode.class, "compare", new MatchPattern(CompressionNode.class, null, new MatchPattern(ReadNode.class, "access", true), CompressionNode_positions, true), new MatchPattern(CompressionNode.class, null, new MatchPattern("value", false), CompressionNode_positions, true), ObjectEqualsNode_positions, true), IfNode_positions, true), ifCompareMemoryObject_invoke, ifCompareMemoryObject_arguments),
        new MatchStatement("ifCompareMemoryObject", new MatchPattern(IfNode.class, null, new MatchPattern(ObjectEqualsNode.class, "compare", new MatchPattern(CompressionNode.class, null, new MatchPattern("value", false), CompressionNode_positions, true), new MatchPattern(CompressionNode.class, null, new MatchPattern(FloatingReadNode.class, "access", true), CompressionNode_positions, true), ObjectEqualsNode_positions, true), IfNode_positions, true), ifCompareMemoryObject_invoke, ifCompareMemoryObject_arguments),
        new MatchStatement("ifCompareMemoryObject", new MatchPattern(IfNode.class, null, new MatchPattern(ObjectEqualsNode.class, "compare", new MatchPattern(CompressionNode.class, null, new MatchPattern(FloatingReadNode.class, "access", true), CompressionNode_positions, true), new MatchPattern(CompressionNode.class, null, new MatchPattern("value", false), CompressionNode_positions, true), ObjectEqualsNode_positions, true), IfNode_positions, true), ifCompareMemoryObject_invoke, ifCompareMemoryObject_arguments),
        new MatchStatement("ifCompareCompressedMemory", new MatchPattern(IfNode.class, null, new MatchPattern(IntegerEqualsNode.class, "compare", new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), IntegerEqualsNode_positions, true), IfNode_positions, true), ifCompareCompressedMemory_invoke, ifCompareCompressedMemory_arguments),
        new MatchStatement("ifCompareCompressedMemory", new MatchPattern(IfNode.class, null, new MatchPattern(IntegerEqualsNode.class, "compare", new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), new MatchPattern("value", false), IntegerEqualsNode_positions, true), IfNode_positions, true), ifCompareCompressedMemory_invoke, ifCompareCompressedMemory_arguments),
        new MatchStatement("ifCompareCompressedMemory", new MatchPattern(IfNode.class, null, new MatchPattern(IntegerLessThanNode.class, "compare", new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), IntegerLessThanNode_positions, true), IfNode_positions, true), ifCompareCompressedMemory_invoke, ifCompareCompressedMemory_arguments),
        new MatchStatement("ifCompareCompressedMemory", new MatchPattern(IfNode.class, null, new MatchPattern(IntegerLessThanNode.class, "compare", new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), new MatchPattern("value", false), IntegerLessThanNode_positions, true), IfNode_positions, true), ifCompareCompressedMemory_invoke, ifCompareCompressedMemory_arguments),
        new MatchStatement("ifCompareCompressedMemory", new MatchPattern(IfNode.class, null, new MatchPattern(IntegerBelowThanNode.class, "compare", new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), IntegerBelowThanNode_positions, true), IfNode_positions, true), ifCompareCompressedMemory_invoke, ifCompareCompressedMemory_arguments),
        new MatchStatement("ifCompareCompressedMemory", new MatchPattern(IfNode.class, null, new MatchPattern(IntegerBelowThanNode.class, "compare", new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), new MatchPattern("value", false), IntegerBelowThanNode_positions, true), IfNode_positions, true), ifCompareCompressedMemory_invoke, ifCompareCompressedMemory_arguments),
        new MatchStatement("ifCompareCompressedMemory", new MatchPattern(IfNode.class, null, new MatchPattern(FloatEqualsNode.class, "compare", new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), FloatEqualsNode_positions, true), IfNode_positions, true), ifCompareCompressedMemory_invoke, ifCompareCompressedMemory_arguments),
        new MatchStatement("ifCompareCompressedMemory", new MatchPattern(IfNode.class, null, new MatchPattern(FloatEqualsNode.class, "compare", new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), new MatchPattern("value", false), FloatEqualsNode_positions, true), IfNode_positions, true), ifCompareCompressedMemory_invoke, ifCompareCompressedMemory_arguments),
        new MatchStatement("ifCompareCompressedMemory", new MatchPattern(IfNode.class, null, new MatchPattern(FloatLessThanNode.class, "compare", new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), FloatLessThanNode_positions, true), IfNode_positions, true), ifCompareCompressedMemory_invoke, ifCompareCompressedMemory_arguments),
        new MatchStatement("ifCompareCompressedMemory", new MatchPattern(IfNode.class, null, new MatchPattern(FloatLessThanNode.class, "compare", new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), new MatchPattern("value", false), FloatLessThanNode_positions, true), IfNode_positions, true), ifCompareCompressedMemory_invoke, ifCompareCompressedMemory_arguments),
        new MatchStatement("ifCompareCompressedMemory", new MatchPattern(IfNode.class, null, new MatchPattern(IntegerEqualsNode.class, "compare", new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), IntegerEqualsNode_positions, true), IfNode_positions, true), ifCompareCompressedMemory_invoke, ifCompareCompressedMemory_arguments),
        new MatchStatement("ifCompareCompressedMemory", new MatchPattern(IfNode.class, null, new MatchPattern(IntegerEqualsNode.class, "compare", new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), new MatchPattern("value", false), IntegerEqualsNode_positions, true), IfNode_positions, true), ifCompareCompressedMemory_invoke, ifCompareCompressedMemory_arguments),
        new MatchStatement("ifCompareCompressedMemory", new MatchPattern(IfNode.class, null, new MatchPattern(IntegerLessThanNode.class, "compare", new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), IntegerLessThanNode_positions, true), IfNode_positions, true), ifCompareCompressedMemory_invoke, ifCompareCompressedMemory_arguments),
        new MatchStatement("ifCompareCompressedMemory", new MatchPattern(IfNode.class, null, new MatchPattern(IntegerLessThanNode.class, "compare", new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), new MatchPattern("value", false), IntegerLessThanNode_positions, true), IfNode_positions, true), ifCompareCompressedMemory_invoke, ifCompareCompressedMemory_arguments),
        new MatchStatement("ifCompareCompressedMemory", new MatchPattern(IfNode.class, null, new MatchPattern(IntegerBelowThanNode.class, "compare", new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), IntegerBelowThanNode_positions, true), IfNode_positions, true), ifCompareCompressedMemory_invoke, ifCompareCompressedMemory_arguments),
        new MatchStatement("ifCompareCompressedMemory", new MatchPattern(IfNode.class, null, new MatchPattern(IntegerBelowThanNode.class, "compare", new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), new MatchPattern("value", false), IntegerBelowThanNode_positions, true), IfNode_positions, true), ifCompareCompressedMemory_invoke, ifCompareCompressedMemory_arguments),
        new MatchStatement("ifCompareCompressedMemory", new MatchPattern(IfNode.class, null, new MatchPattern(FloatEqualsNode.class, "compare", new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), FloatEqualsNode_positions, true), IfNode_positions, true), ifCompareCompressedMemory_invoke, ifCompareCompressedMemory_arguments),
        new MatchStatement("ifCompareCompressedMemory", new MatchPattern(IfNode.class, null, new MatchPattern(FloatEqualsNode.class, "compare", new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), new MatchPattern("value", false), FloatEqualsNode_positions, true), IfNode_positions, true), ifCompareCompressedMemory_invoke, ifCompareCompressedMemory_arguments),
        new MatchStatement("ifCompareCompressedMemory", new MatchPattern(IfNode.class, null, new MatchPattern(FloatLessThanNode.class, "compare", new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), FloatLessThanNode_positions, true), IfNode_positions, true), ifCompareCompressedMemory_invoke, ifCompareCompressedMemory_arguments),
        new MatchStatement("ifCompareCompressedMemory", new MatchPattern(IfNode.class, null, new MatchPattern(FloatLessThanNode.class, "compare", new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), new MatchPattern("value", false), FloatLessThanNode_positions, true), IfNode_positions, true), ifCompareCompressedMemory_invoke, ifCompareCompressedMemory_arguments),
        new MatchStatement("binaryReadCompressed", new MatchPattern(IntegerAddNode.class, null, new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), IntegerAddNode_positions, true), binaryReadCompressed_invoke, binaryReadCompressed_arguments),
        new MatchStatement("binaryReadCompressed", new MatchPattern(IntegerAddNode.class, null, new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), new MatchPattern("value", false), IntegerAddNode_positions, true), binaryReadCompressed_invoke, binaryReadCompressed_arguments),
        new MatchStatement("binaryReadCompressed", new MatchPattern(IntegerSubNode.class, null, new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), IntegerSubNode_positions, true), binaryReadCompressed_invoke, binaryReadCompressed_arguments),
        new MatchStatement("binaryReadCompressed", new MatchPattern(IntegerMulNode.class, null, new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), IntegerMulNode_positions, true), binaryReadCompressed_invoke, binaryReadCompressed_arguments),
        new MatchStatement("binaryReadCompressed", new MatchPattern(IntegerMulNode.class, null, new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), new MatchPattern("value", false), IntegerMulNode_positions, true), binaryReadCompressed_invoke, binaryReadCompressed_arguments),
        new MatchStatement("binaryReadCompressed", new MatchPattern(FloatAddNode.class, null, new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), FloatAddNode_positions, true), binaryReadCompressed_invoke, binaryReadCompressed_arguments),
        new MatchStatement("binaryReadCompressed", new MatchPattern(FloatAddNode.class, null, new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), new MatchPattern("value", false), FloatAddNode_positions, true), binaryReadCompressed_invoke, binaryReadCompressed_arguments),
        new MatchStatement("binaryReadCompressed", new MatchPattern(FloatSubNode.class, null, new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), FloatSubNode_positions, true), binaryReadCompressed_invoke, binaryReadCompressed_arguments),
        new MatchStatement("binaryReadCompressed", new MatchPattern(FloatMulNode.class, null, new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), FloatMulNode_positions, true), binaryReadCompressed_invoke, binaryReadCompressed_arguments),
        new MatchStatement("binaryReadCompressed", new MatchPattern(FloatMulNode.class, null, new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), new MatchPattern("value", false), FloatMulNode_positions, true), binaryReadCompressed_invoke, binaryReadCompressed_arguments),
        new MatchStatement("binaryReadCompressed", new MatchPattern(OrNode.class, null, new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), OrNode_positions, true), binaryReadCompressed_invoke, binaryReadCompressed_arguments),
        new MatchStatement("binaryReadCompressed", new MatchPattern(OrNode.class, null, new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), new MatchPattern("value", false), OrNode_positions, true), binaryReadCompressed_invoke, binaryReadCompressed_arguments),
        new MatchStatement("binaryReadCompressed", new MatchPattern(XorNode.class, null, new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), XorNode_positions, true), binaryReadCompressed_invoke, binaryReadCompressed_arguments),
        new MatchStatement("binaryReadCompressed", new MatchPattern(XorNode.class, null, new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), new MatchPattern("value", false), XorNode_positions, true), binaryReadCompressed_invoke, binaryReadCompressed_arguments),
        new MatchStatement("binaryReadCompressed", new MatchPattern(AndNode.class, null, new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), AndNode_positions, true), binaryReadCompressed_invoke, binaryReadCompressed_arguments),
        new MatchStatement("binaryReadCompressed", new MatchPattern(AndNode.class, null, new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), new MatchPattern("value", false), AndNode_positions, true), binaryReadCompressed_invoke, binaryReadCompressed_arguments),
        new MatchStatement("binaryReadCompressed", new MatchPattern(IntegerAddNode.class, null, new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), IntegerAddNode_positions, true), binaryReadCompressed_invoke, binaryReadCompressed_arguments),
        new MatchStatement("binaryReadCompressed", new MatchPattern(IntegerAddNode.class, null, new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), new MatchPattern("value", false), IntegerAddNode_positions, true), binaryReadCompressed_invoke, binaryReadCompressed_arguments),
        new MatchStatement("binaryReadCompressed", new MatchPattern(IntegerSubNode.class, null, new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), IntegerSubNode_positions, true), binaryReadCompressed_invoke, binaryReadCompressed_arguments),
        new MatchStatement("binaryReadCompressed", new MatchPattern(IntegerMulNode.class, null, new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), IntegerMulNode_positions, true), binaryReadCompressed_invoke, binaryReadCompressed_arguments),
        new MatchStatement("binaryReadCompressed", new MatchPattern(IntegerMulNode.class, null, new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), new MatchPattern("value", false), IntegerMulNode_positions, true), binaryReadCompressed_invoke, binaryReadCompressed_arguments),
        new MatchStatement("binaryReadCompressed", new MatchPattern(FloatAddNode.class, null, new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), FloatAddNode_positions, true), binaryReadCompressed_invoke, binaryReadCompressed_arguments),
        new MatchStatement("binaryReadCompressed", new MatchPattern(FloatAddNode.class, null, new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), new MatchPattern("value", false), FloatAddNode_positions, true), binaryReadCompressed_invoke, binaryReadCompressed_arguments),
        new MatchStatement("binaryReadCompressed", new MatchPattern(FloatSubNode.class, null, new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), FloatSubNode_positions, true), binaryReadCompressed_invoke, binaryReadCompressed_arguments),
        new MatchStatement("binaryReadCompressed", new MatchPattern(FloatMulNode.class, null, new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), FloatMulNode_positions, true), binaryReadCompressed_invoke, binaryReadCompressed_arguments),
        new MatchStatement("binaryReadCompressed", new MatchPattern(FloatMulNode.class, null, new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), new MatchPattern("value", false), FloatMulNode_positions, true), binaryReadCompressed_invoke, binaryReadCompressed_arguments),
        new MatchStatement("binaryReadCompressed", new MatchPattern(OrNode.class, null, new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), OrNode_positions, true), binaryReadCompressed_invoke, binaryReadCompressed_arguments),
        new MatchStatement("binaryReadCompressed", new MatchPattern(OrNode.class, null, new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), new MatchPattern("value", false), OrNode_positions, true), binaryReadCompressed_invoke, binaryReadCompressed_arguments),
        new MatchStatement("binaryReadCompressed", new MatchPattern(XorNode.class, null, new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), XorNode_positions, true), binaryReadCompressed_invoke, binaryReadCompressed_arguments),
        new MatchStatement("binaryReadCompressed", new MatchPattern(XorNode.class, null, new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), new MatchPattern("value", false), XorNode_positions, true), binaryReadCompressed_invoke, binaryReadCompressed_arguments),
        new MatchStatement("binaryReadCompressed", new MatchPattern(AndNode.class, null, new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), AndNode_positions, true), binaryReadCompressed_invoke, binaryReadCompressed_arguments),
        new MatchStatement("binaryReadCompressed", new MatchPattern(AndNode.class, null, new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), new MatchPattern("value", false), AndNode_positions, true), binaryReadCompressed_invoke, binaryReadCompressed_arguments),
        new MatchStatement("readCompressed", new MatchPattern(ReadNode.class, null, new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), readCompressed_invoke, readCompressed_arguments),
        new MatchStatement("readCompressed", new MatchPattern(ReadNode.class, null, new MatchPattern(PiNode.class, null, new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), PiNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), readCompressed_invoke, readCompressed_arguments),
        new MatchStatement("readCompressed", new MatchPattern(FloatingReadNode.class, null, new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), readCompressed_invoke, readCompressed_arguments),
        new MatchStatement("readCompressed", new MatchPattern(FloatingReadNode.class, null, new MatchPattern(PiNode.class, null, new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), PiNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), readCompressed_invoke, readCompressed_arguments),
        new MatchStatement("writeCompressed", new MatchPattern(WriteNode.class, null, new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), new MatchPattern("value", false), WriteNode_positions, true), writeCompressed_invoke, writeCompressed_arguments),
        new MatchStatement("writeCompressed", new MatchPattern(WriteNode.class, null, new MatchPattern(PiNode.class, null, new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), PiNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), new MatchPattern("value", false), WriteNode_positions, true), writeCompressed_invoke, writeCompressed_arguments)
    ));
    // CheckStyle: resume line length check

    public Class<? extends NodeLIRBuilder> forClass() {
        return AMD64HotSpotNodeLIRBuilder.class;
    }

    @Override
    public List<MatchStatement> statements() {
        return statements;
    }
}
